using System;
//using System.Collections.Generic;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Text.RegularExpressions;
using System.Media;

namespace GangDemo
{

    public partial class Form1 : Form
    {
        [DllImport("kernel32.dll")]
        public static extern bool Beep(int Frequenz, int Dauer);

        [DllImport("UPP1X_DLL.dll")]
        private static extern void AbortAll();
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void GetProgIDs(ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void InitChannel(int channel, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void GetFileNames(int channel, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void OpenAfile(int channel, string FileName, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void DeleteAfile(int channel, string FileName, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void DownloadFile(int channel, string FileName, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void GetProjParams(int channel, string FileName, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void CloseAfile(int channel, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void GetTargVolt(int channel, ref int Volt, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void EraseDevice(int channel, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void GetProgStatus(int channel, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void ProgDevice(int channel, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void ReleaseTarget(int channel, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void VerifyDevice(int channel, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void GetFuses(int channel, char selfuse, ref int fuse, ref prgResult result, StringBuilder resString);

        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void DownOverBlockF(int channel, IntPtr PData, int Adr, int Count, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void DownOverBlockE(int channel, IntPtr PData, int Adr, int Count, ref prgResult result, StringBuilder resString);
        [DllImport("UPP1X_DLL.dll", CharSet = CharSet.Ansi)]
        private static extern void DownOverBlockU(int channel, IntPtr PData, int Adr, int Count, ref prgResult result, StringBuilder resString);
        // .......


        [DllImport("kernel32.dll")]
        private static extern long GetTickCount();


        private int ProgrammersFound = 0;
        private string SelectedFile;
        private bool FileIsOpen = false;
        private string strLast = ".";
        private long StartTime;
        private long  EndTime;
        // only first UPP in use for this demo

        enum chState { cIdle, cProg, cErase, cVerify };
        enum prgResult : int
        {
            resNone, resOk, progDone, noProg, progFound, progBusy, progDefect, progIdle, progComErr,
            progTimeOutErr, PwrDownErr, PwrSupplyErr, SignatureErr,
            invPassword, limitExc,
            eraChip, eraFlash, eraEEp, eraUsrRow, ProtectedErr, NotEmptyErr,
            prgFlash, prgEEp, prgUsrRow,
            verifyFlash, verifyEEp, verifyUsrRow, VerifyErr,
            dwnLoading, ParmErr, dwnLoadErrF, dwnLoadErrE, dwnLoadErrU,
            invFile, invFName, FileExist, FileNotFound, FileErr, FileDwnErr,
            MMCok, MMCprotected, MMCnoMedia, MMCmissing, MMCinitFailed, MMCresetFailed,
            MMCcheckFailed, MMCnoProg, MMCprogBusy
        };

        private chState cStatus = chState.cIdle;

        //**********************************************************************
        public Form1()
        {
            InitializeComponent();

        }

        public class Tokenizer
        {
            private string m_TotalStr;
            private string[] m_SplittedStr;
            private int m_Index;
            char[] delimiters = new char[] { '\r', '\n' };

            public Tokenizer(string str)
            {
                m_TotalStr = str;
                if (str == null)
                    m_SplittedStr = new string[0];
                else
                    m_SplittedStr = str.Split(delimiters, StringSplitOptions.RemoveEmptyEntries);
                //Regex.Split(str,"\r\n");
                m_Index = -1;
            }

            public void Reset()
            {
                m_Index = -1;
            }

            public bool HasMoreTokens()
            {
                return CountTokens() > m_Index;
            }

            public int CountTokens()
            {
                return m_SplittedStr.Length;
            }

            public string NextToken()
            {
                m_Index++;
                if (HasMoreTokens())
                {
                    string s = m_SplittedStr[m_Index];
                    if (s == "")
                        return NextToken();
                    return s;
                }
                else
                    return null;
            }
        }
        //**************************************************************************   
        //**********************************************************************
        private void Form1_Shown(object sender, EventArgs e)
        {
            DisableButtons(groupBox1);
            DisableButtons(groupBox2);
            DisableButtons(groupBox3);
            groupBox4.Enabled = false;
            toolTip1.SetToolTip(this.groupBox4, "patch x-bytes while  ProgAll ");
        }

        //**********************************************************************
        private void DisableButtons(GroupBox grp)
        {
            for (int i = 0; i < grp.Controls.Count; i++)
            {
                var btn = grp.Controls[i] as Button;
                if (btn != null)
                {
                    if (btn.Name != "btnAbortAll")
                    {
                        btn.Enabled = false;
                    }
                }
            }
        }
        //**********************************************************************
        private void EnableButtons(GroupBox grp)
        {
            for (int i = 0; i < grp.Controls.Count; i++)
            {
                var btn = grp.Controls[i] as Button;
                if (btn != null)
                {
                    if (btn.Name != "btnAbortAll")
                    {
                        btn.Enabled = true;
                    }
                }
            }
        }
        //**********************************************************************
        private void comboBoxFiles_SelectedIndexChanged(object sender, EventArgs e)
        {
            SelectedFile = comboBoxFiles.Text;
        }

        //**********************************************************************
        private void btnAbortAll_Click(object sender, EventArgs e)
        {
            Application.UseWaitCursor = true;
            try
            {
                cStatus = chState.cIdle;
                Memo.Clear();
                comboBoxFiles.IntegralHeight = false;
                comboBoxFiles.Items.Clear();
                comboBoxFiles.Text = "";
                FileIsOpen = false;
                statusBar.Items[0].Text = "";
                TimerProgStatus.Enabled = false;
                DisableButtons(groupBox1);
                DisableButtons(groupBox2);
                DisableButtons(groupBox3);
                DisableButtons(groupBox4);
                groupBox2.Enabled = false;
                btnOpenAFile.Text = "OpenAfile";
                Memo.AppendText("AbortAll():\r\n");
                Application.DoEvents();
                AbortAll();
                btnGetProgIDs.Enabled = true;
            }
            finally
            {
                Application.UseWaitCursor = false;
            }
        }
        //**********************************************************************
        private void btnGetProgIds_Click(object sender, EventArgs e)
        {
            prgResult iStat = 0;
            int cnt = 0;
            bool isDemo = false;
            string strRes = " ";
            string str1 = " ";
            statusBar.Items[0].Text = "";
            StringBuilder strProg = new StringBuilder(500); //serial = max 15 * 16 chars
            GetProgIDs(ref iStat, strProg);
            strRes = strProg.ToString();
            Tokenizer tok = new Tokenizer(strRes);
            ProgrammersFound = 0;

            for (cnt = 0; cnt < tok.CountTokens(); cnt++)
            {
                String value = tok.NextToken();
                if ((value.Length > 15) && (cnt > 0))
                {
                    isDemo = true;
                    str1 = "->" + value;
                }
                else
                {
                    str1 = "Device: " + Convert.ToString(cnt) + "->" + value;
                }


                Memo.AppendText("GetProgIDs: " + str1 + "\r\n");
            }

            if (isDemo) cnt--;

            {
                statusBar.Items[0].Text = " Devices found " + Convert.ToString(cnt);
                Memo.AppendText("GetProgIDs: Devices found " + Convert.ToString(cnt) + "\r\n");
            }
            if (cnt > 0)
                btnInitChannel.Enabled = true;
            ProgrammersFound = cnt;

        }
        //**********************************************************************
        private void btnInitChannel_Click(object sender, EventArgs e)
        {
            prgResult iStat = 0;
            string strRes = " ";
            statusBar.Items[0].Text = "";
            StringBuilder strProg = new StringBuilder(100);
            InitChannel(0, ref iStat, strProg);
            strRes = strProg.ToString();

            Memo.AppendText("Initchannel Channel: 0" +
             "-> Result: " + Convert.ToString(iStat) + ", Message: " + strRes + "\r\n");
            if (iStat == prgResult.progFound)
            {
                groupBox2.Enabled = true;
                btnGetFiles.Enabled = true;
                btnTargetVoltage.Enabled = true;
                btnDownloadFile.Enabled = true;
                groupBox4.Enabled = true;
            }

        }
        //**********************************************************************
        private void btnGetFiles_Click(object sender, EventArgs e)
        {
            prgResult iStat = 0;
            int cnt = 0;
            string strRes = " ";
            statusBar.Items[0].Text = "";
            StringBuilder strProg = new StringBuilder(500);
            comboBoxFiles.Items.Clear();
            btnDeleteFile.Enabled = false;
            comboBoxFiles.Text = "";
            SelectedFile = "";
            GetFileNames(0, ref iStat, strProg);
            strRes = strProg.ToString();

            Memo.AppendText("GetFileNames Channel: 0" +
             "-> Result: " + Convert.ToString(iStat) + "\r\n");
            if (iStat == prgResult.resOk)
            {
                Tokenizer tok = new Tokenizer(strRes);
                for (cnt = 0; cnt < tok.CountTokens(); cnt++)
                {
                    String value = tok.NextToken();
                    comboBoxFiles.Items.Add(value);
                    Memo.AppendText("GetFileNames Channel: 0, Place: " + Convert.ToString(cnt) + " -> " + value + "\r\n");
                }
            }
            if (cnt > 0)
            {
                comboBoxFiles.Enabled = true;
                statusBar.Items[0].Text = "Files found: " + Convert.ToString(cnt);
                comboBoxFiles.SelectedIndex = 0;
                btnOpenAFile.Enabled = true;
                btnDeleteFile.Enabled = true;
                btnGetProjParams.Enabled = true;
                SelectedFile = comboBoxFiles.Text;
            }
        }
        //**********************************************************************
        private void CloseFile()
        {
            prgResult iStat = 0;
            string strRes = " ";
            statusBar.Items[0].Text = "";
            StringBuilder strProg = new StringBuilder(100);
            CloseAfile(0, ref iStat, strProg);
            strRes = strProg.ToString();
            Memo.AppendText("CloseAfile Channel: 0" +
             "-> Result: " + Convert.ToString(iStat) + ", Message: " + strRes + "\r\n");
            //if (iStat == prgResult.progFound)
            {
                groupBox2.Enabled = true;
                btnGetFiles.Enabled = true;
                btnTargetVoltage.Enabled = true;
                btnOpenAFile.Text = "OpenAfile";
                btnEraseDevice.Enabled = false;
                btnVerifyAll.Enabled = false;
                btngetFuses.Enabled = false;
                btnProgDevice.Enabled = false;
                comboBoxFiles.Enabled = true;
                btnGetFiles.Enabled = true;
                FileIsOpen = false;
                statusBar.Items[0].Text = " FileOpen: none";
            }

        }
        //**********************************************************************
        private void btnOpenAFile_Click(object sender, EventArgs e)
        {
            prgResult iStat = 0;
            string strRes = " ";
            statusBar.Items[0].Text = "";
            StringBuilder strProg = new StringBuilder(100);
            if (SelectedFile != "")
            {
                if (!FileIsOpen)
                {

                    OpenAfile(0, SelectedFile, ref iStat, strProg);
                    strRes = strProg.ToString();
                    statusBar.Items[0].Text = " FileOpen: " + SelectedFile;
                    Memo.AppendText("OpenAFile Channel: 0 ,'" + SelectedFile +
                     "' -> Result: " + Convert.ToString(iStat) + ", Message: " + strRes + "\r\n");
                    if (iStat == prgResult.resOk)
                    {
                        // btnGetFiles.Enabled = true;
                        btnEraseDevice.Enabled = true;
                        btnProgDevice.Enabled = true;
                        btnVerifyAll.Enabled = true;
                        btngetFuses.Enabled = true;
                        FileIsOpen = true;
                        btnOpenAFile.Text = "CloseAfile";
                        btnGetFiles.Enabled = false;
                        comboBoxFiles.Enabled = false;
                    }
                }
                else
                {

                    CloseFile();

                }
            }
            else
            {
                Memo.AppendText("OpenAFile Channel: 0 , ERROR : not File seleted !!\r\n");
            }
        }
        //**********************************************************************
        private void btnTargetVoltage_Click(object sender, EventArgs e)
        {
            prgResult iStat = 0;
            int Volt = 0;
            string realVolt;
            string strRes = " ";
            statusBar.Items[0].Text = "";
            StringBuilder strProg = new StringBuilder(100);
            GetTargVolt(0, ref Volt, ref iStat, strProg);
            strRes = strProg.ToString();
            if (Volt != 0) { realVolt = Convert.ToString(Volt / 100) + " Volt "; }
            else
            {
                realVolt = "0.0 Volt ";
            }
            Memo.AppendText("GetTargVolt Channel: 0 , " +
             "-> Result: " + Convert.ToString(iStat) + ", Message: " + strRes + " Volt" + "\r\n");
        }
        //**********************************************************************
        private void btnEraseDevice_Click(object sender, EventArgs e)
        {
            prgResult iStat = 0;
            string strRes = " ";
            statusBar.Items[0].Text = "";
            StringBuilder strProg = new StringBuilder(100);
            EraseDevice(0, ref iStat, strProg);
            strRes = strProg.ToString();
            Memo.AppendText("EraseDevice Channel: 0" +
             "-> Result: " + Convert.ToString(iStat) + ", Message: " + strRes + "\r\n");

        }
        //**********************************************************************
        private void DoVerifyDevice()
        {
            prgResult iStat = 0;
            string strRes = " ";
            statusBar.Items[0].Text = "";
            StringBuilder strProg = new StringBuilder(100);
            if (FileIsOpen)
            {
                VerifyDevice(0, ref iStat, strProg);
                strRes = strProg.ToString();
                Memo.AppendText("VerifyDevice Channel: 0" +
                 "-> Result: " + Convert.ToString(iStat) + ", Message: " + strRes + "\r\n");
                if (iStat == prgResult.resOk)
                {
                    StartTime = GetTickCount();
                    cStatus = chState.cProg;
                    TimerProgStatus.Enabled = true;
                }
            }
            else
            {
                Memo.AppendText("VerifyDevice Channel: 0 , ERROR : no File open !!\r\n");
            }
        }


        //**********************************************************************
        private void btnProgDevice_Click(object sender, EventArgs e)
        {
            prgResult res = 0;
            string strRes = "";
            string strData = "";
            int adr;
            statusBar.Items[0].Text = "";
            StringBuilder buf = new StringBuilder(100);
            if (FileIsOpen)
            {
                if (cbDownOverFlash.Checked)
                {
                    //  usable for patching a serial number or a MAC address
                    //  while programming the selected memory type , max 32 bytes
                    //  or
                    //  DownOverBlockE for EEprom
                    //  DownOverBlockU for UserRow
                    adr = Convert.ToInt32(edDownOverFlash.Text);
                    strData = edSerial.Text;
                    DownOverBlockF(0, Marshal.StringToHGlobalAnsi(strData), adr, strData.Length, ref res, buf);
                    strRes = buf.ToString();
                    Memo.AppendText("ProgDevice DownOverBlockF is set : 0 -> Result: " + Convert.ToString(res) + ", Message: " + strRes + "\r\n");
                    if (res != prgResult.resOk)
                        return;
                }

                ProgDevice(0, ref res, buf);
                strRes = buf.ToString();
                Memo.AppendText("ProgDevice Channel: 0" + "-> Result: " + Convert.ToString(res) + ", Message: " + strRes + "\r\n");
                if (res == prgResult.resOk)
                {
                    StartTime = GetTickCount();
                    cStatus = chState.cProg;
                    TimerProgStatus.Enabled = true;
                }
            }
            else
            {
                Memo.AppendText("ProgDevice Channel: 0 , ERROR : no File open !!\r\n");
            }
        }
        //**********************************************************************
        private void btnVerifyAll_Click(object sender, EventArgs e)
        {
            DoVerifyDevice();
        }
        //**********************************************************************
        private void btnDeleteFile_Click(object sender, EventArgs e)
        {
            prgResult res = 0;
            string strRes = " ";
            statusBar.Items[0].Text = "";
            StringBuilder buf = new StringBuilder(100);
            DialogResult result;

            if (SelectedFile != "")
            {
                if (!FileIsOpen)
                {
                    result = MessageBox.Show("Delete file " + SelectedFile, "Question", MessageBoxButtons.YesNo);
                    if (result == System.Windows.Forms.DialogResult.Yes)
                    {
                        DeleteAfile(0, SelectedFile, ref  res, buf);
                        strRes = buf.ToString();
                        statusBar.Items[0].Text = " FileOpen: " + SelectedFile;
                        Memo.AppendText("DeleteAfile Channel: 0 ,'" + SelectedFile + "' -> Result: " + Convert.ToString(res) + ", Message: " + strRes + "\r\n");
                        if (res == prgResult.resOk)
                        {
                            btnGetFiles_Click(sender, e);
                        }
                    }
                }
                else
                {
                    CloseFile();
                }
            }
            else
            {
                Memo.AppendText("DeleteAfile Channel: 0 , ERROR : not File seleted !!" + "\r\n");
            }
        }

        //**********************************************************************
        private void btnDownloadFile_Click(object sender, EventArgs e)
        {
            prgResult res = 0;
            string strRes = " ";
            string strFile = " ";
            statusBar.Items[0].Text = "";
            StringBuilder buf = new StringBuilder(100);
            TimerProgStatus.Enabled = false;
            try
            {
                if (!FileIsOpen)   // !! or try GetFileState() to verify no file is open
                {
                    OpenDialog1.FileName = "";
                    if (OpenDialog1.ShowDialog() == DialogResult.OK)
                    {
                        strFile = OpenDialog1.FileName;
                        if (strFile == "") return;

                        Memo.AppendText("DownloadAFile in progress " + strFile.Substring(strFile.LastIndexOf("\\", strFile.Length - 2) + 1) + " ....." + "\r\n");
                        groupBox1.Enabled = false;
                        Application.UseWaitCursor = true;
                        Application.DoEvents();
                        DownloadFile(0, strFile, ref res, buf);
                        strRes = buf.ToString();
                        Memo.AppendText("DownloadAFile Channel: 0 -> Result: " + Convert.ToString(res) + ", Message: " + strRes + "\r\n");
                        Beep(1000, 500);
                        if (res == prgResult.resOk)
                        {
                            btnGetFiles_Click(sender, e);
                        }
                    }
                }
                else
                {
                    Memo.AppendText("DownloadAFile Channel: 0 , ERROR :  File is open !!" + "\r\n");
                }
            }
            finally
            {
                groupBox1.Enabled = true;
                Application.UseWaitCursor = false;
            }

        }
        //**********************************************************************
        private void DoGetFuses()
        {
            prgResult res = 0;
            int Locks = 255, fuseLo = 255, fuseHi = 255, fuseExt = 255, fuseI = 255, fuseJ = 255,
                fuseK = 255, Cal0 = 255, Cal1 = 255, Cal2 = 255, Cal3 = 255;
            string strRes = " ";
            statusBar.Items[0].Text = "";
            StringBuilder PstBuffer = new StringBuilder(100);


            if (FileIsOpen)
            {
                Cursor.Current = Cursors.WaitCursor;
                try
                {
                    // "L", "F", "H", "E", "0", "1", "2", "3"
                    GetFuses(0, 'L', ref Locks, ref res, PstBuffer);
                    // if (res != prgResult.resOk)
                    {
                        strRes = PstBuffer.ToString();
                        Memo.AppendText("GetFuse Channel: 0" +
                         "-> Result: " + Convert.ToString(res) + ", Message: " + strRes +
                         "    , Atmel fuse notation  enabled = 0, disabled = 1 " + "\r\n");
                        // Exit !!!!!!
                    }
                    GetFuses(0, 'F', ref fuseLo, ref res, PstBuffer);   // Fuse 0
                    // todo Error check
                    GetFuses(0, 'H', ref fuseHi, ref res, PstBuffer);   // Fuse 1
                    // todo Error check ...
                    GetFuses(0, 'E', ref fuseExt, ref res, PstBuffer);  // Fuse 2
                    GetFuses(0, 'I', ref fuseI, ref res, PstBuffer);    // Fuse 3
                    GetFuses(0, 'J', ref fuseJ, ref res, PstBuffer);    // Fuse 4
                    GetFuses(0, 'K', ref fuseK, ref res, PstBuffer);    // Fuse 5                  
                    GetFuses(0, '0', ref Cal0, ref res, PstBuffer);
                    GetFuses(0, '1', ref Cal1, ref res, PstBuffer);
                    GetFuses(0, '2', ref Cal2, ref res, PstBuffer);
                    GetFuses(0, '3', ref Cal3, ref res, PstBuffer);

                    Memo.AppendText("   Lockbits\t : 0x" + Locks.ToString("X2") + "\r\n");
                    Memo.AppendText("   Fuse0\t\t : 0x" + fuseLo.ToString("X2") + "\r\n");
                    Memo.AppendText("   Fuse1\t\t : 0x" + fuseHi.ToString("X2") + "\r\n");
                    Memo.AppendText("   Fuse2\t\t : 0x" + fuseExt.ToString("X2") + "\r\n");
                    Memo.AppendText("   Fuse3\t\t : 0x" + fuseI.ToString("X2") + "\r\n");
                    Memo.AppendText("   Fuse4\t\t : 0x" + fuseJ.ToString("X2") + "\r\n");
                    Memo.AppendText("   Fuse5\t\t : 0x" + fuseK.ToString("X2") + "\r\n");
                    Memo.AppendText("   Cal0\t\t : 0x" + Cal0.ToString("X2") + "\r\n");
                    Memo.AppendText("   Cal1\t\t : 0x" + Cal1.ToString("X2") + "\r\n");
                    Memo.AppendText("   Cal2\t\t : 0x" + Cal2.ToString("X2") + "\r\n");
                    Memo.AppendText("   Cal3\t\t : 0x" + Cal3.ToString("X2") + "\r\n");
                }
                finally
                {
                    Cursor.Current = Cursors.Default;
                }

            }
            else
            {
                Memo.AppendText("GetFuse Channel: 0 , ERROR : no File open !!\r\n");
            }
        }
        //**********************************************************************
        private void btnGetProjParams_Click(object sender, EventArgs e)
        {
            prgResult res = 0;
            string strRes = "";
            int cnt;
            string str1 = "";
            statusBar.Items[0].Text = "";
            StringBuilder buf = new StringBuilder(512);
            char[] delimiters = new char[] { '\r', '\n' };

            if (SelectedFile != "")
            {
                GetProjParams(0, SelectedFile, ref  res, buf);
                strRes = buf.ToString();
                Memo.AppendText("GetProjParams: " + SelectedFile + "\r\n");
                String[] strList;


                strList = strRes.Split(delimiters, StringSplitOptions.RemoveEmptyEntries);
                for (cnt = 0; cnt < strList.Length; cnt++)
                {
                    str1 = "Parm: " + Convert.ToString(cnt) + "-> " + strList[cnt];
                    Memo.AppendText("   " + str1 + "\r\n");
                } // file is now closed
                CloseFile();
            }
            else
                Memo.AppendText("GetProjParams: no File selected" + "\r\n");

        }
        //**********************************************************************
        private void btngetFuses_Click(object sender, EventArgs e)
        {
            DoGetFuses();
        }
        //**********************************************************************
        //**********************************************************************
        private void TimerProgStatus_Tick(object sender, EventArgs e)
        {
            prgResult iStat = 0;
            string strRes = " ";
            statusBar.Items[0].Text = "";
            StringBuilder strProg = new StringBuilder(100);
            int allIdle = 0;
            groupBox2.Enabled = false;
            for (int idx = 0; idx < ProgrammersFound; idx++)
            {
                if (cStatus != chState.cIdle)
                {
                    GetProgStatus(0, ref iStat, strProg);
                    strRes = strProg.ToString();
                    if (strRes != "")
                    {

                    }
                    if (strLast != strRes)
                    {
                        switch (iStat)
                        {
                            case prgResult.progDone:
                                {
                                    EndTime = GetTickCount(); 
                                    Beep(2000, 100);
                                    Memo.AppendText("\r\nGetProgStatus >done< :) " + Convert.ToString(((EndTime - StartTime) / 1000)) + " sec. \r\n");
                                    ReleaseTarget(0, ref iStat, strProg);
                                    strRes = strProg.ToString();
                                    // if desired !!
                                    Memo.AppendText("ReleaseTarget Channel: 0" +
                                    "-> Result: " + Convert.ToString(iStat) + ", Message: " + strRes + "\r\n");
                                    groupBox2.Enabled = true;
                                    cStatus = chState.cIdle;
                                    allIdle++;
                                    statusBar.Items[0].Text = " programming finished";
                                    break;
                                }
                            case prgResult.eraChip:
                                {
                                    Memo.AppendText("\r\nGetProgStatus >c< erase Chip\r\n");
                                    break;
                                }
                            case prgResult.verifyUsrRow:
                                {
                                    Memo.AppendText("\r\nGetProgStatus >U< verify UserRow \r\n");
                                    break;
                                }
                            case prgResult.prgUsrRow:
                                {
                                    Memo.AppendText("\r\nGetProgStatus >U< program UserRow \r\n");
                                    break;
                                }

                            case prgResult.verifyEEp:
                                {
                                    Memo.AppendText("\r\nGetProgStatus >E< verify EEprom \r\n");
                                    break;
                                }
                            case prgResult.prgEEp:
                                {
                                    Memo.AppendText("\r\nGetProgStatus >E< program EEprom \r\n");
                                    break;
                                }
                            case prgResult.verifyFlash:
                                {
                                    Memo.AppendText("\r\nGetProgStatus >V< verify Flash \r\n");
                                    break;
                                }
                            case prgResult.prgFlash:
                                {
                                    Memo.AppendText("\r\nGetProgStatus >F< program Flash\r\n");
                                    break;
                                }
                            case prgResult.limitExc:
                            case prgResult.PwrDownErr:
                            case prgResult.SignatureErr:
                            case prgResult.ProtectedErr:
                            case prgResult.NotEmptyErr:
                            case prgResult.VerifyErr:
                            case prgResult.FileErr:
                                {
                                    groupBox2.Enabled = true;
                                    cStatus = chState.cIdle;
                                    allIdle++;
                                    Memo.AppendText("\r\nGetProgStatus >Error< \r\n");
                                    Beep(1000, 500);
                                    Beep(500, 100);
                                    Beep(1000, 500);
                                    break;
                                }
                            case prgResult.progTimeOutErr:
                                {
                                    groupBox2.Enabled = true;
                                    allIdle = 999;
                                    cStatus = chState.cIdle;
                                    Memo.AppendText("\r\nGetProgStatus >8< communication TimeOut\r\n");
                                    break;
                                }

                        }
                    }
                    else
                    {
                        Memo.AppendText("*");
                    }

                    strLast = strRes;

                }
                else
                {
                    allIdle++;
                }


            }
            if (allIdle >= ProgrammersFound)
            {
                TimerProgStatus.Enabled = false;
                groupBox2.Enabled = true;
            }

        }

        private void Memo_DoubleClick(object sender, EventArgs e)
        {
            Memo.Clear();
            statusBar.Items[0].Text = "";
        }

        private void Memo_TextChanged(object sender, EventArgs e)
        {
            BeginInvoke(new MethodInvoker(delegate
            {
                SetSelection();
            }));
        }
        private void SetSelection()
        {
            Memo.SelectionStart = Memo.Text.Length;
            Memo.ScrollToCaret();
        }

        private void toolTip1_Popup(object sender, PopupEventArgs e)
        {

        }









        //**********************************************************************





    }
}
