// ---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
// ---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

// ---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner)
{

}

// ---------------------------------------------------------------------------
void __fastcall TForm1::DisableButtons(TGroupBox* grp)
{
    for (int i = 0; i < grp->ControlCount; i++)
    {
        if (grp->Controls[i]->Name != "btnAbortAll")
        {
            grp->Controls[i]->Enabled = false;
        }
    }
}
// ---------------------------------------------------------------------------
void __fastcall TForm1::EnableButtons(TGroupBox* grp)
{
    for (int i = 0; i < grp->ControlCount; i++)
    {
        if (grp->Controls[i]->Name != "btnAbortAll")
        {
            grp->Controls[i]->Enabled = true;
        }
    }
}
// ---------------------------------------------------------------------------
void __fastcall TForm1::btnAbortAllClick(TObject *Sender)
{
    Screen->Cursor = crHourGlass;
    try
    {
        cStatus = cIdle;
        Memo->Clear();

        comboBoxFiles->Items->Clear();
        comboBoxFiles->Text = "";
        FileIsOpen = false;
        statusBar->Panels->Items[0]->Text = "";
        TimerProgStatus->Enabled = false;
        DisableButtons(groupBox1);
        DisableButtons(groupBox2);
        DisableButtons(groupBox3);
        groupBox2->Enabled = false;
        btnOpenAFile->Caption = "OpenAfile";
        Memo->Lines->Add("AbortAll():");
        Application->ProcessMessages();
        AbortAll();
        btnGetProgIDs->Enabled = true;
    }
    __finally
    {
        Screen->Cursor = crDefault;
    }
}
// ---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
    DisableButtons(groupBox1);
    DisableButtons(groupBox2);
    DisableButtons(groupBox3);
    DisableButtons(groupBox4);
    comboBoxFiles->Clear();
}
// ---------------------------------------------------------------------------

void __fastcall TForm1::btnGetProgIDsClick(TObject *Sender)
{
    int res ;
    int cnt;
    bool isDemo = false;
    String value;
    char buf[256];
    TStringList *strList;
    String str1 = "";
    statusBar->Panels->Items[0]->Text = "";
    ProgrammersFound = 0;

    GetProgIDs(res, buf);
    strList = new TStringList;
    try
    {
        strList->Text = String(buf);
        for (cnt = 0; cnt < strList->Count; cnt++)
        {
            value = strList->Strings[cnt];
            if ((value.Length() > 15) )
            {
                isDemo = true;
                str1 = "->" + value;
            }
            else
            {
                str1 = "Device: " + IntToStr(cnt) + "->" + value;
            }

            Memo->Lines->Add("GetProgIDs: " + str1);
        }
        if (isDemo)
            cnt--;

        {
            statusBar->Panels->Items[0]->Text =
                " Devices found " + IntToStr(cnt);
            Memo->Lines->Add("GetProgIDs: Devices found " + IntToStr(cnt));
        }
        if (cnt > 0)
            btnInitChannel->Enabled = true;
        ProgrammersFound = cnt;
    }
    __finally
    {
        delete strList;
    }

}
// ---------------------------------------------------------------------------

void __fastcall TForm1::btnInitChannelClick(TObject *Sender)
{
    int res = 0;
    char buf[256];
    String strRes = "";
    InitChannel(0, res, buf); // exception wenn kein UPP vorhanden
    strRes = String(buf);
    Memo->Lines->Add("Initchannel Channel: 0 -> Result: " + IntToStr(res) +
                     ", Message: " + strRes);
    if (res == int(progFound))
    {
        groupBox2->Enabled = true;
        groupBox3->Enabled = true;
        groupBox4->Enabled = true;
        EnableButtons(groupBox4);
        btnGetFiles->Enabled = true;
        btnTargetVoltage->Enabled = true;
        btnDownloadFile->Enabled = true;
    }
}
// ---------------------------------------------------------------------------
void __fastcall TForm1::btnGetFilesClick(TObject *Sender)
{
    int res = 0;
    int cnt;
    int found = 0;
    char buf[256];
    String value;
    TStringList *strList;
    statusBar->Panels->Items[0]->Text = "";
    comboBoxFiles->Clear();
    comboBoxFiles->Text = "";
    strList = new TStringList;
    SelectedFile = "";
    try
    {
        GetFileNames(0, res, buf);
        strList->Text = String(buf);

        Memo->Lines->Add("GetFileNames Channel: 0 -> Result: " + IntToStr(res));
        if (res == int(resOk))
        {
            for (cnt = 0; cnt < strList->Count; cnt++)
            {
                value = strList->Strings[cnt];
                if (value != "")
                {
                    comboBoxFiles->Items->Add(value);
                    Memo->Lines->Add("GetFileNames Channel: 0, Place: " +
                                     IntToStr(cnt) + " -> " + value);
                    found++;
                }
            }
        }
        if (found > 0)
        {
            comboBoxFiles->Enabled = true;
            statusBar->Panels->Items[0]->Text =
                "Files found: " + IntToStr(found);
            comboBoxFiles->ItemIndex = 0;
            btnOpenAFile->Enabled = true;
            btnDeleteFile->Enabled = true;
            btnGetProjParams->Enabled = true;
            SelectedFile = comboBoxFiles->Text;
        }
    }
    __finally
    {
        delete strList;
    }
}

// ---------------------------------------------------------------------------

void __fastcall TForm1::CloseFile()
{
    int res = 0;
    String strRes = "";
    char buf[256];
    statusBar->Panels->Items[0]->Text = "";

    CloseAfile(0, res, buf);
    strRes = String(buf);
    Memo->Lines->Add("CloseAfile Channel: 0 -> Result: " + IntToStr(res) +
                     ", Message: " + strRes);
    // if (res == int(progFound))
    {
        groupBox2->Enabled = true;
        btnGetFiles->Enabled = true;
        btnTargetVoltage->Enabled = true;
        btnOpenAFile->Caption = "OpenAfile";
        btnEraseDevice->Enabled = false;
        btnVerifyAll->Enabled = false;
        btngetFuses->Enabled = false;
        btnProgDevice->Enabled = false;
        comboBoxFiles->Enabled = true;
        btnGetFiles->Enabled = true;
        btnDownloadFile->Enabled = true;
        FileIsOpen = false;
        statusBar->Panels->Items[0]->Text = " FileOpen: none";
    }
}

// ----------------------------------------------------------------------------
void __fastcall TForm1::btnOpenAFileClick(TObject *Sender)
{
    int res = 0;
    String strRes = "";
    char buf[256];
    statusBar->Panels->Items[0]->Text = "";

    if (SelectedFile != "")
    {
        if (!FileIsOpen)
        {
            OpenAfile(0, SelectedFile.c_str(), res, buf);
            strRes = String(buf);
            statusBar->Panels->Items[0]->Text =
                " FileOpen: " + SelectedFile;
            Memo->Lines->Add("OpenAFile Channel: 0 ,'" + SelectedFile +
                             "' -> Result: " + IntToStr(res) + ", Message: " + strRes);
            if (res == int(resOk))
            {
                btnEraseDevice->Enabled = true;
                btnProgDevice->Enabled = true;
                btnVerifyAll->Enabled = true;
                btngetFuses->Enabled = true;
                FileIsOpen = true;
                btnOpenAFile->Caption = "CloseAfile";
                btnGetFiles->Enabled = false;
                comboBoxFiles->Enabled = false;
                btnDownloadFile->Enabled = false;
                comboBoxFiles->ItemIndex = 0;
            }
        }
        else
        {
            CloseFile();
        }
    }
    else
    {
        Memo->Lines->Add
        ("OpenAFile Channel: 0 , ERROR : not File seleted !!");
    }
}

//---------------------------------------------------------------------------

void __fastcall TForm1::btnDeleteFileClick(TObject *Sender)
{
    int res = 0;
    String strRes = "";
    char buf[256];
    statusBar->Panels->Items[0]->Text = "";

    if (SelectedFile != "")
    {
        if (!FileIsOpen)
        {
            if(Application->MessageBox(("Delete file "+SelectedFile).c_str() ,"Question",MB_YESNO) == IDYES)
            {
                DeleteAfile(0, SelectedFile.c_str(), res, buf);
                strRes = String(buf);
                statusBar->Panels->Items[0]->Text = " FileOpen: " + SelectedFile;
                Memo->Lines->Add("DeleteAfile Channel: 0 ,'" + SelectedFile +
                                 "' -> Result: " + IntToStr(res) + ", Message: " + strRes);
                if (res == int(resOk))
                {
                    btnGetFilesClick(Sender);
                }
            }
        }
        else
        {
            CloseFile();
        }
    }
    else
    {
        Memo->Lines->Add
        ("DeleteAfile Channel: 0 , ERROR : not File seleted !!");
    }
}
// ---------------------------------------------------------------------------
void __fastcall TForm1::btnEraseDeviceClick(TObject *Sender)
{
    int res = 0;
    String strRes = " ";
    char buf[256];
    statusBar->Panels->Items[0]->Text = "";
    EraseDevice(0, res, buf);
    strRes = String(buf);
    Memo->Lines->Add("EraseDevice Channel: 0 -> Result: " + IntToStr(res) +
                     ", Message: " + strRes);
}
// ---------------------------------------------------------------------------

void __fastcall TForm1::btnTargetVoltageClick(TObject *Sender)
{
    int res = 0;
    int Volt = 0;
    String realVolt = "";
    String strRes = "";
    char buf[256];
    statusBar->Panels->Items[0]->Text = "";
    GetTargVolt(0, Volt, res, buf);
    strRes = String(buf);
    if (Volt != 0)
    {
        realVolt = IntToStr(Volt / 100) + " Volt ";
    }
    else
    {
        realVolt = "0.0 Volt ";
    }
    Memo->Lines->Add("GetTargVolt Channel: 0 , -> Result: " +
                     IntToStr(res) + ", Message: " + strRes + " Volt");
}

// ---------------------------------------------------------------------------
void __fastcall TForm1::btnProgDeviceClick(TObject *Sender)
{
    int res = 0;
    String strRes = "";
    char buf[256];
    String strData = edSerial->Text;
    int adr = StrToInt(edDownOverFlash->Text);
    statusBar->Panels->Items[0]->Text = "";
    if (FileIsOpen)
    {
        if (cbDownOverFlash->Checked)
        {
            //  usable for patching a serial number or a MAC address
            //  while programming the selected memory type , max 32 bytes
            //  or
            //  DownOverBlockE for EEprom
            //  DownOverBlockU for UserRow
            DownOverBlockF(0, (int*)strData.c_str(), adr, strData.Length(), res, buf);
            strRes = String(buf);
            Memo->Lines->Add("ProgDevice DownOverBlockF is set : 0 -> Result: " +
                             IntToStr(res) + ", Message: " + strRes);
            if (res != int(resOk))
                exit;
        }

        ProgDevice(0, res, buf);
        strRes = String(buf);
        Memo->Lines->Add("ProgDevice Channel: 0 -> Result: " +
                         IntToStr(res) + ", Message: " + strRes);
        StartTime = GetTickCount();
        if (res == int(resOk))
        {
            statusBar->Panels->Items[0]->Text = "ProgDevice "+ SelectedFile;
            cStatus = cProg;
            TimerProgStatus->Enabled = true;
        }
    }
    else
    {
        Memo->Lines->Add("ProgDevice Channel: 0 , ERROR : no File open !!");
    }
}

// ---------------------------------------------------------------------------
void __fastcall TForm1::btnVerifyAllClick(TObject *Sender)
{
    int res = 0;
    String strRes = " ";
    char buf[256];
    statusBar->Panels->Items[0]->Text = "";

    if (FileIsOpen)
    {
        VerifyDevice(0, res, buf);
        strRes = String(buf);
        Memo->Lines->Add("VerifyDevice Channel: 0 -> Result: " +
                         IntToStr(res) + ", Message: " + strRes);
        StartTime = GetTickCount();
        if (res == int(resOk))
        {
            cStatus = cProg;
            TimerProgStatus->Enabled = true;
        }
    }
    else
    {
        Memo->Lines->Add
        ("VerifyDevice Channel: 0 , ERROR : no File open !!");
    }

}
// ---------------------------------------------------------------------------
// save a User File to UPP1x on MMC card
void __fastcall TForm1::btnDownloadFileClick(TObject *Sender)
{
    int res = 0;
    String strRes = "";
    char buf[256];
    String strFile = "";
    statusBar->Panels->Items[0]->Text = "";
    TimerProgStatus->Enabled = false;
    try
    {
        if (!FileIsOpen)   // !! or try GetFileState() to verify no file is open
        {
            OpenDialog1->FileName = "";
            if (OpenDialog1->Execute())
            {
                strFile = OpenDialog1->FileName;
                if (strFile == "")  exit;
            }
            Memo->Lines->Add("DownloadAFile in progress " + UpperCase(ExtractFileName(strFile)) +" .....");
            groupBox1->Enabled = false;
            Application->ProcessMessages();
            Screen->Cursor = crHourGlass;
            DownloadFile(0,strFile.c_str(), res, buf);
            strRes = String(buf);
            Memo->Lines->Add("DownloadAFile Channel: 0 -> Result: " +
                             IntToStr(res) + ", Message: " + strRes);
            Beep(1000, 500);
            if (res == int(resOk))
            {
                btnGetFilesClick(Sender);
            }
        }
        else
        {
            Memo->Lines->Add
            ("DownloadAFile Channel: 0 , ERROR :  File is open !!");
        }
    }
    __finally
    {
        groupBox1->Enabled = true;
        Screen->Cursor = crDefault;
    }
}

//---------------------------------------------------------------------------

void __fastcall TForm1::btnGetProjParamsClick(TObject *Sender)
{
    int res ;
    int cnt;
    char buf[1024];
    TStringList *strList;
    String str1 = "";
    statusBar->Panels->Items[0]->Text = "";

    if (SelectedFile != "")
    {
        GetProjParams(0, SelectedFile.c_str(), res, buf);
        Memo->Lines->Add("GetProjParams: "+ SelectedFile);
        strList = new TStringList;
        try
        {
            strList->Text = String(buf);
            for (cnt = 0; cnt < strList->Count; cnt++)
            {
                str1 = "Parm: " + IntToStr(cnt) + "-> " + strList->Strings[cnt];
                Memo->Lines->Add("   " + str1);
            }
        }
        __finally
        {
            delete strList;
        }
        // file is now closed by DLL
        CloseFile();
    }
    else
        Memo->Lines->Add("GetProjParams: no File selected");
}

// ---------------------------------------------------------------------------
void __fastcall TForm1::btngetFusesClick(TObject *Sender)
{
    int res = 0;
    int Locks = 255, fuseLo = 255, fuseHi = 255, fuseExt = 255, fuseI = 255,
        fuseJ = 255, fuseK = 255, Cal0 = 255, Cal1 = 255, Cal2 =
                255, Cal3 = 255;
    char buf[256];
    String strRes = "";
    statusBar->Panels->Items[0]->Text = "";

    if (FileIsOpen)
    {
        // "L", "F", "H", "E", "0", "1", "2", "3"
        GetFuses(0, 'L', Locks, res, buf);
        // if (res != int(resOk))
        {
            strRes = String(buf);
            Memo->Lines->Add("GetFuse Channel: 0 -> Result: " +
                             IntToStr(res) + ", Message: " + strRes +
                             "    , Atmel fuse notation  enabled = 0, disabled = 1 ");
            // Errror = Exit !!!!!!

        }
        GetFuses(0, 'F', fuseLo, res, buf); // Fuse 0
        // todo Error check
        GetFuses(0, 'H', fuseHi, res, buf); // Fuse 1
        // todo Error check ...
        GetFuses(0, 'E', fuseExt, res, buf); // Fuse 2
        GetFuses(0, 'I', fuseI, res, buf); // Fuse 3
        GetFuses(0, 'J', fuseJ, res, buf); // Fuse 4
        GetFuses(0, 'K', fuseK, res, buf); // Fuse 5
        GetFuses(0, '0', Cal0, res, buf);
        GetFuses(0, '1', Cal1, res, buf);
        GetFuses(0, '2', Cal2, res, buf);
        GetFuses(0, '3', Cal3, res, buf);

        Memo->Lines->Add("   Lockbits\t : 0x" + IntToHex(Locks, 2));
        Memo->Lines->Add("   Fuse0\t\t : 0x" + IntToHex(fuseLo, 2));
        Memo->Lines->Add("   Fuse1\t\t : 0x" + IntToHex(fuseHi, 2));
        Memo->Lines->Add("   Fuse2\t\t : 0x" + IntToHex(fuseExt, 2));
        Memo->Lines->Add("   Fuse3\t\t : 0x" + IntToHex(fuseI, 2));
        Memo->Lines->Add("   Fuse4\t\t : 0x" + IntToHex(fuseJ, 2));
        Memo->Lines->Add("   Fuse5\t\t : 0x" + IntToHex(fuseK, 2));
        Memo->Lines->Add("   Cal0\t\t : 0x" + IntToHex(Cal0, 2));
        Memo->Lines->Add("   Cal1\t\t : 0x" + IntToHex(Cal1, 2));
        Memo->Lines->Add("   Cal2\t\t : 0x" + IntToHex(Cal2, 2));
        Memo->Lines->Add("   Cal3\t\t : 0x" + IntToHex(Cal3, 2));

    }
    else
    {
        Memo->Lines->Add("GetFuse Channel: 0 , ERROR : no File open !!");
    }

}

// ---------------------------------------------------------------------------
void __fastcall TForm1::comboBoxFilesChange(TObject *Sender)
{
    SelectedFile = comboBoxFiles->Text;
    statusBar->Panels->Items[0]->Text = " Fileselected: " + SelectedFile;
}
// ---------------------------------------------------------------------------

void __fastcall TForm1::MemoDblClick(TObject *Sender)
{
    Memo->Clear();
}

// ---------------------------------------------------------------------------
void __fastcall TForm1::TimerProgStatusTimer(TObject *Sender)
{
    int res = 0;
    String strRes = "";
    char buf[256];
    int allIdle = 0;
    groupBox2->Enabled = false;
    for (int idx = 0; idx < ProgrammersFound; idx++)
    {
        if (cStatus != cIdle)
        {
            GetProgStatus(0, res, buf);
            strRes = String(buf);

            if (strRes != "")
            {

            }
            if (strLast != strRes)
            {
                switch (prgResult(res))
                {
                case progDone:
                {
                    EndTime = GetTickCount();
                    Beep(2000, 100);
                    Memo->Lines->Add("\r\nGetProgStatus >done< in  " + FloatToStr((double(EndTime - StartTime) / 1000)) + " sec.");

                    ReleaseTarget(0, res, buf);
                    strRes = String(buf);
                    // if desired !!
                    Memo->Lines->Add
                    ("ReleaseTarget Channel: 0 -> Result: " +
                     IntToStr(res) + ", Message: " + strRes);
                    groupBox2->Enabled = true;
                    cStatus = cIdle;
                    allIdle++;
                    statusBar->Panels->Items[0]->Text =
                        " programming finished";
                    break;
                }
                case eraChip:
                {
                    Memo->Lines->Add
                    ("\r\nGetProgStatus >c< erase Chip\r\n");
                    break;
                }
                case verifyUsrRow:
                {
                    Memo->Lines->Add
                    ("\r\nGetProgStatus >U< verify UserRow \r\n");
                    break;
                }
                case prgUsrRow:
                {
                    Memo->Lines->Add
                    ("\r\nGetProgStatus >U< program UserRow \r\n");
                    break;
                }

                case verifyEEp:
                {
                    Memo->Lines->Add
                    ("\r\nGetProgStatus >E< verify EEprom \r\n");
                    break;
                }
                case prgEEp:
                {
                    Memo->Lines->Add
                    ("\r\nGetProgStatus >E< program EEprom \r\n");
                    break;
                }
                case verifyFlash:
                {
                    Memo->Lines->Add
                    ("\r\nGetProgStatus >V< verify Flash \r\n");
                    break;
                }
                case prgFlash:
                {
                    Memo->Lines->Add
                    ("\r\nGetProgStatus >F< program Flash\r\n");
                    break;
                }
                case limitExc:
                case PwrDownErr:
                case SignatureErr:
                case ProtectedErr:
                case NotEmptyErr:
                case VerifyErr:
                case FileErr:
                {
                    groupBox2->Enabled = true;
                    cStatus = cIdle;
                    allIdle++;
                    Memo->Lines->Add("\r\nGetProgStatus >Error< \r\n");
                    Beep(1000, 500);
                    Beep(500, 100);
                    Beep(1000, 500);
                    break;
                }
                case progTimeOutErr:
                {
                    groupBox2->Enabled = true;
                    allIdle = 999;
                    cStatus = cIdle;
                    Memo->Lines->Add
                    ("\r\nGetProgStatus >8< communication TimeOut\r\n");
                    break;
                }
                /*
                default:
                {
                    groupBox2->Enabled = true;
                    allIdle = 999;
                    cStatus = cIdle;
                    Memo->Lines->Add
                    ("\r\nGetProgStatus >?< unknown error \r\n");
                    break;
                }
                */

                }
            }
            else
            {

                Memo->Lines->BeginUpdate();
                Memo->Lines->Text = Memo->Lines->Text + ("*");
                Memo->Lines->EndUpdate();

            }

            strLast = strRes;

        }
        else
        {
            allIdle++;
        }

    }
    if (allIdle >= ProgrammersFound)
    {
        TimerProgStatus->Enabled = false;
        groupBox2->Enabled = true;
    }

}

// ---------------------------------------------------------------------------



//---------------------------------------------------------------------------

