//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <time.h>

extern "C"
   {

	  void __stdcall AbortAll          ( void );
          void __stdcall InitChannel       ( int channel, int &res, char *resStr );
          void __stdcall GetProgStatus     ( int channel, int &res, char *resStr );
	  void __stdcall ClosePort         ( int channel, int &res, char *resStr );
          void __stdcall ReleaseTarget     ( int channel, int &res, char *resStr );
	  void __stdcall OpenAfile         ( int channel, char *fileName, int &res, char *resStr );
	  void __stdcall GetFileState      ( int channel, int &res, char *resStr );
	  void __stdcall CloseAfile        ( int channel, int &res, char *resStr );
	  void __stdcall DeleteAfile       ( int channel, char *fileName, int &res, char *resStr );
	  void __stdcall GetFileNames      ( int channel, int &res, char *resStr );
	  void __stdcall CheckAfile        ( int channel, char *projName, int &res, char *resStr );
	  void __stdcall GetProjParams     ( int channel, char *projName, int &res, char *resStr );
	  void __stdcall GetProgIDs        ( int &res, char *resStr );
	  void __stdcall CheckProgrammer   ( int channel, int &res, char *resStr );
	  void __stdcall DownloadFile      ( int channel, char *projname, int &res, char *resStr );
	  void __stdcall GetTargVolt       ( int channel, int &volt, int &res, char *resStr );
	  void __stdcall CheckDevice       ( int channel, int &res, char *resStr );
	  void __stdcall ProgDevice        ( int channel, int &res, char *resStr );
	  void __stdcall EraseDevice       ( int channel, int &res, char *resStr );
	  void __stdcall VerifyDevice      ( int channel, int &res, char *resStr );
          void __stdcall GetFuses          ( int channel, char selFuse, int &fuse, int &res, char *resStr );

          void __stdcall DownOverBlockF(int channel,int *Block, int dest, int count, int &res, char *resStr);
          // ........
   }

 enum chState { cIdle, cProg, cErase, cVerify };
  enum prgResult
        {
            resNone, resOk, progDone, noProg, progFound, progBusy, progDefect, progIdle, progComErr,
            progTimeOutErr, PwrDownErr, PwrSupplyErr, SignatureErr,
            invPassword, limitExc,
            eraChip, eraFlash, eraEEp, eraUsrRow, ProtectedErr, NotEmptyErr,
            prgFlash, prgEEp, prgUsrRow,
            verifyFlash, verifyEEp, verifyUsrRow, VerifyErr,
            dwnLoading, ParmErr, dwnLoadErrF, dwnLoadErrE, dwnLoadErrU,
            invFile, invFName, FileExist, FileNotFound, FileErr, FileDwnErr,
            MMCok, MMCprotected, MMCnoMedia, MMCmissing, MMCinitFailed, MMCresetFailed,
            MMCcheckFailed, MMCnoProg, MMCprogBusy
        };

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// Von der IDE verwaltete Komponenten
        TStatusBar *statusBar;
        TPanel *Panel1;
        TMemo *Memo;
        TGroupBox *groupBox1;
        TGroupBox *groupBox2;
        TButton *btnAbortAll;
        TButton *btnGetProgIDs;
        TButton *btnInitChannel;
        TButton *btnGetFiles;
        TButton *btnOpenAFile;
        TButton *btnEraseDevice;
        TComboBox *comboBoxFiles;
        TButton *btnProgDevice;
        TButton *btnVerifyAll;
        TButton *btngetFuses;
        TButton *btnTargetVoltage;
        TTimer *TimerProgStatus;
        TOpenDialog *OpenDialog1;
        TButton *btnDeleteFile;
        TGroupBox *groupBox3;
        TButton *btnDownloadFile;
        TCheckBox *cbDownOverFlash;
        TEdit *edDownOverFlash;
        TLabel *Label1;
        TEdit *edSerial;
        TLabel *Label2;
        TGroupBox *groupBox4;
        TButton *btnGetProjParams;
        void __fastcall btnAbortAllClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall btnGetProgIDsClick(TObject *Sender);
        void __fastcall btnInitChannelClick(TObject *Sender);
        void __fastcall btnGetFilesClick(TObject *Sender);
        void __fastcall btnOpenAFileClick(TObject *Sender);
        void __fastcall btnEraseDeviceClick(TObject *Sender);
        void __fastcall btnTargetVoltageClick(TObject *Sender);
        void __fastcall comboBoxFilesChange(TObject *Sender);
        void __fastcall MemoDblClick(TObject *Sender);
        void __fastcall TimerProgStatusTimer(TObject *Sender);
        void __fastcall btnProgDeviceClick(TObject *Sender);
        void __fastcall btnVerifyAllClick(TObject *Sender);
        void __fastcall btngetFusesClick(TObject *Sender);
        void __fastcall btnDownloadFileClick(TObject *Sender);
        void __fastcall btnDeleteFileClick(TObject *Sender);
        void __fastcall btnGetProjParamsClick(TObject *Sender);


private:	// Anwender-Deklarationen
        void __fastcall DisableButtons(TGroupBox* grp);
        void __fastcall EnableButtons(TGroupBox* grp);
        void __fastcall CloseFile();

public:		// Anwender-Deklarationen
        __fastcall TForm1(TComponent* Owner);

private:
         chState cStatus;
         bool FileIsOpen;
         String strLast;
         int ProgrammersFound ;
         String SelectedFile;
         DWORD StartTime;
         DWORD EndTime;
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
