Unit Main;

Interface

Uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, TypInfo, uSplitEx;

Type
  TPrgResult = (resNone, resOk, progDone, noProg, progFound, progBusy, progDefect, progIdle, progComErr,
    progTimeOutErr, PwrDownErr, PwrSupplyErr, SignatureErr,
    invPassword, limitExc,
    eraChip, eraFlash, eraEEp, eraUsrRow, ProtectedErr, NotEmptyErr,
    prgFlash, prgEEp, prgUsrRow,
    verifyFlash, verifyEEp, verifyUsrRow, VerifyErr,
    dwnLoading, ParmErr, dwnLoadErrF, dwnLoadErrE, dwnLoadErrU,
    invFile, invFName, FileExist, FileNotFound, FileErr, FileDwnErr,
    MMCok, MMCprotected, MMCnoMedia, MMCmissing, MMCinitFailed, MMCresetFailed,
    MMCcheckFailed, MMCnoProg, MMCprogBusy);

  chState = (cIdle, cProg, cVerify);
  
Type
  TForm1 = Class(TForm)
    StatusBar: TStatusBar;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    btnAbortAll: TButton;
    btnGetProgIDs: TButton;
    btnInitChannel: TButton;
    btnGetFiles: TButton;
    btnOpenAFile: TButton;
    btnEraseDevice: TButton;
    btnProgDevice: TButton;
    btnTargetVoltage: TButton;
    btnVerifyAll: TButton;
    btngetFuses: TButton;
    comboBoxFiles: TComboBox;
    TimerProgStatus: TTimer;
    Memo: TMemo;
    btnDeleteFile: TButton;
    btnDownloadFile: TButton;
    btnGetProjParams: TButton;
    GroupBox4: TGroupBox;
    cbDownOverFlash: TRadioButton;
    edDownOverAddr: TEdit;
    edSerial: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox3: TGroupBox;
    OpenDialog1: TOpenDialog;
    Procedure btnAbortAllClick(Sender: TObject);
    Procedure btnGetProgIDsClick(Sender: TObject);
    Procedure FormShow(Sender: TObject);
    Procedure comboBoxFilesSelect(Sender: TObject);
    Procedure btnInitChannelClick(Sender: TObject);
    Procedure btnGetFilesClick(Sender: TObject);
    Procedure btnOpenAFileClick(Sender: TObject);
    Procedure btnEraseDeviceClick(Sender: TObject);
    Procedure btnTargetVoltageClick(Sender: TObject);
    Procedure btnProgDeviceClick(Sender: TObject);
    Procedure btnVerifyAllClick(Sender: TObject);
    Procedure TimerProgStatusTimer(Sender: TObject);
    Procedure btngetFusesClick(Sender: TObject);
    Procedure MemoDblClick(Sender: TObject);
    Procedure btnDeleteFileClick(Sender: TObject);
    Procedure btnDownloadFileClick(Sender: TObject);
    Procedure btnGetProjParamsClick(Sender: TObject);
    procedure comboBoxFilesChange(Sender: TObject);
  private
    { Private-Deklarationen }
    ProgrammersFound: integer;
    SelectedFile: String;
    FileIsOpen: boolean;
    strLast: String;
    cStatus: chState;
    StartTime,
      EndTime: Cardinal;

  private
    Procedure DisableButtons(grp: TGroupBox);
    Procedure CloseFile;
    Function GetTyp(res: integer): String;
    // only first UPP in use for this demo
  public
    { Public-Deklarationen }
  End;

Var
  Form1             : TForm1;

Implementation

Const
  CRLF              = #13#10;

Procedure InitChannel(Channel: integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progDefect, noProg, progFound

Procedure CheckProgrammer(Channel: integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = MMCok, MMCnoMedia, MMCmissing,MMCinitFailed, MMCresetFailed, MMCcheckFailed, MMCnoProg, MMCprogBusy

Procedure ClosePort(Channel: integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = resNone, noProg

Procedure GetProgIDs(Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';

Procedure GetProgStatus(Channel: integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = resNone, limitExc, eraChip, prgEEp, prgFlash, progDone, PwrDownErr,
//       SignatureErr, ProtectedErr, NotEmptyErr, VerifyErr, prgUsrRow, verifyUsrRow

Procedure AbortAll; stdcall; external 'UPP1X_DLL.dll';

Procedure ReleaseTarget(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';

Procedure OpenAfile(Channel: integer; FileName: PChar; Var res: integer; resStr: PChar); stdcall; external
  'UPP1X_DLL.dll';
// res = resOk, FileNotFound, invFile, PwrDownErr, SignatureErr, ProtectedErr, progTimeOutErr

Procedure GetFileState(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = resOk, noProg, invFName, FileNotFound

Procedure CloseAfile(Channel: integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';

Procedure DeleteAfile(Channel: integer; FileName: PChar; Var res: integer; resStr: PChar); stdcall; external
  'UPP1X_DLL.dll';
// res = progBusy, invFName, notFound, errProtected, resOk

Procedure DownloadFile(Channel: Integer; ProjName: PChar; Var res: integer; resStr: PChar); stdcall; external
  'UPP1X_DLL.dll';
// res = progBusy, limitExc, errProgType, progProtected, dwnLoadErrP, dwnLoadErrF,
//       dwnLoadErrE, dwnLoadErrU, dwnLoadErr, noProg, resOk

Procedure GetFileNames(Channel: integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk

Procedure CheckAfile(Channel: integer; ProjName: PChar; Var res: integer; resStr: PChar); stdcall; external
  'UPP1X_DLL.dll';
// res = ????????

Procedure GetProjParams(Channel: integer; ProjName: PChar; Var res: integer; resStr: PChar); stdcall; external
  'UPP1X_DLL.dll';
// res = ????????

Procedure GetTargVolt(Channel: integer; Var Volt: integer; Var res: integer; resStr: PChar); stdcall; external
  'UPP1X_DLL.dll';
// res = progBusy, noProg, errProgType, resOk

                // "L", "F", "H", "E", "I", "J", "K", "L", "0", "1", "2", "3"
Procedure GetFuses(Channel: integer; selfuse: char; Var fuse: integer; Var res: integer; resStr: PChar); stdcall;
  external 'UPP1X_DLL.dll';
// res = resOk, progBusy, noProg, errProgType, errPwrDown, errSignature,
//       notFound, dwnLoadErr

Procedure CheckDevice(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = resNone, progBusy, noProg, errProgType, errPwrDown, errSignature,
//       errNotEmpty, errProtected

Procedure ProgDevice(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk  rest of states must be done with "GetProgStatus"

Procedure ProgFlash(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk  rest of states must be done with "GetProgStatus"

Procedure ProgEEprom(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk  rest of states must be done with "GetProgStatus"

Procedure ProgUsrRow(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk  rest of states must be done with "GetProgStatus"

                // "L", "F", "H", "E", "I", "J", "K", "L", "0", "1", "2", "3"
Procedure ProgFuses(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk  rest of states must be done with "GetProgStatus"

Procedure ProgLockBits(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk  rest of states must be done with "GetProgStatus"

Procedure EraseDevice(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk  rest of states must be done with "GetProgStatus"

Procedure VerifyDevice(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk  rest of states must be done with "GetProgStatus"

Procedure VerifyFlashOnly(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk  rest of states must be done with "GetProgStatus"

Procedure VerifyEEpromOnly(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk  rest of states must be done with "GetProgStatus"

Procedure VerifyUsrRowOnly(Channel: Integer; Var res: integer; resStr: PChar); stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, resOk  rest of states must be done with "GetProgStatus"

Procedure DownFileBlockF(Channel: Integer; Block: Pointer; dest, count: Integer; Var res: integer; resStr: PChar);
  stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, progProtected, dwnLoadErr, resOk

Procedure DownFileBlockE(Channel: Integer; Block: Pointer; dest, count: Integer; Var res: integer; resStr: PChar);
  stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, progProtected, dwnLoadErr, resOk

Procedure DownFileBlockU(Channel: Integer; Block: Pointer; dest, count: Integer; Var res: integer; resStr: PChar);
  stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, progProtected, dwnLoadErr, resOk

Procedure UpFileBlockF(Channel: Integer; Block: Pointer; source, count: Integer; Var res: integer; resStr: PChar);
  stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, progProtected, dwnLoadErr, resOk

Procedure UpFileBlockE(Channel: Integer; Block: Pointer; source, count: Integer; Var res: integer; resStr: PChar);
  stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, progProtected, dwnLoadErr, resOk

Procedure UpFileBlockU(Channel: Integer; Block: Pointer; source, count: Integer; Var res: integer; resStr: PChar);
  stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, progProtected, dwnLoadErr, resOk

Procedure ReadBackChipF(Channel: Integer; Block: Pointer; source: Integer; Var res: integer; resStr: PChar); stdcall;
  external 'UPP1X_DLL.dll';
// res = progBusy, noProg, progProtected, dwnLoadErr, resOk

Procedure ReadBackChipE(Channel: Integer; Block: Pointer; source, count: Integer; Var res: integer; resStr: PChar);
  stdcall; external 'UPP1X_DLL.dll';
// res = progBusy, noProg, progProtected, dwnLoadErr, resOk

Procedure ReadBackChipU(Channel: Integer; Block: Pointer; source: Integer; Var res: integer; resStr: PChar); stdcall;
  external 'UPP1X_DLL.dll';
// res = progBusy, noProg, progProtected, dwnLoadErr, resOk

Procedure DownProgBlockF(Channel: Integer; Block: Pointer; dest: Integer; Var res: integer; resStr: PChar); stdcall;
  external 'UPP1X_DLL.dll';

Procedure DownProgBlockE(Channel: Integer; Block: Pointer; dest, count: Integer; Var res: integer; resStr: PChar);
  stdcall; external 'UPP1X_DLL.dll';

Procedure DownProgBlockU(Channel: Integer; Block: Pointer; dest: Integer; Var res: integer; resStr: PChar); stdcall;
  external 'UPP1X_DLL.dll';

Procedure DownOverBlockF(Channel: Integer; Block: Pointer; dest, count: Integer; Var res: integer; resStr: PChar);
  stdcall; external 'UPP1X_DLL.dll';

Procedure DownOverBlockE(Channel: Integer; Block: Pointer; dest, count: Integer; Var res: integer; resStr: PChar);
  stdcall; external 'UPP1X_DLL.dll';

Procedure DownOverBlockU(Channel: Integer; Block: Pointer; dest, count: Integer; Var res: integer; resStr: PChar);
  stdcall; external 'UPP1X_DLL.dll';

{$R *.dfm}

Function TForm1.GetTyp(res: integer): String;
Begin
  result := GetEnumName(TypeInfo(TPrgResult), res);
End;
{-----------------------------------------------------------------------------}

Procedure TForm1.DisableButtons(grp: TGroupBox);
Var
  I                 : integer;
Begin
  For i := 0 To grp.ControlCount - 1 Do
  Begin
    If grp.controls[i] Is TButton Then
      If (TButton(grp.controls[i]).Name <> 'btnAbortAll') Then
      Begin
        grp.Controls[i].Enabled := false;
      End;
  End;
End;
{-----------------------------------------------------------------------------}
Procedure TForm1.FormShow(Sender: TObject);
Begin
  DisableButtons(groupBox1);
  DisableButtons(groupBox2);
  comboBoxFiles.Enabled := false;
End;
Procedure TForm1.MemoDblClick(Sender: TObject);
Begin
  Memo.Clear;
End;

{-----------------------------------------------------------------------------}
Procedure TForm1.btnAbortAllClick(Sender: TObject);
Begin
  Screen.Cursor := crHourGlass;
  Try
    cStatus := cIdle;
    Memo.Clear;
    comboBoxFiles.Items.Clear;
    comboBoxFiles.Text := '';
    comboBoxFiles.Enabled := false;
    FileIsOpen := false;
    statusBar.Panels[0].Text := '';
    TimerProgStatus.Enabled := false;
    DisableButtons(groupBox1);
    DisableButtons(groupBox2);
    DisableButtons(groupBox3);
    groupBox2.Enabled := false;
    btnOpenAFile.Caption := 'OpenAfile';
    Memo.Lines.Add('AbortAll():');
    Application.ProcessMessages;
    AbortAll();
    btnGetProgIDs.Enabled := true;
  Finally
    Screen.Cursor := crDefault;
  End;
End;
{-----------------------------------------------------------------------------}
Procedure TForm1.btnGetProgIDsClick(Sender: TObject);
Var
  res               : integer;
  cnt               : integer;
  isDemo            : boolean;
  strRes            : String;
  value             : String;
  str1              : String;
  toks              : IStrings;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;

Begin
  ProgrammersFound := 0;
  pBuf := @stBuffer;
  statusBar.Panels[0].Text := '';
  GetProgIDs(res, pBuf);
  strRes := pBuf;
  toks := SplitEx(strRes, CRLF);
  isDemo := false;
  For cnt := 0 To Toks.Count - 1 Do
  Begin
    value := toks[cnt];
    If ((length(value) > 15) And (cnt > 0)) Then
    Begin
      isDemo := true;
      str1 := ' - > ' + value;
    End
    Else
    Begin
      str1 := 'Device: ' + IntToStr(cnt) + ' - > ' + value;
    End;
    Memo.Lines.Add('GetProgIDs: ' + str1);
  End;

  If (isDemo) Then
    dec(cnt);

  statusBar.Panels[0].Text := ' Devices found ' + IntToStr(cnt);
  Memo.Lines.Add('GetProgIDs: Devices found ' + IntToStr(cnt));

  If (cnt > 0) Then
  Begin
    btnInitChannel.Enabled := true;
    ProgrammersFound := cnt;
  End;
End;
{-----------------------------------------------------------------------------}
Procedure TForm1.btnGetProjParamsClick(Sender: TObject);
Var
  res, cnt          : integer;
  filesFound        : integer;
  strRes            : String;
  str1              : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;
  toks              : ISTrings;
  value             : String;
Begin
  pBuf := @stBuffer;
  statusBar.Panels[0].Text := '';
  str1 := '';

  If (SelectedFile <> '') Then
  Begin
    GetProjParams(0, PChar(SelectedFile), res, pbuf);
    Memo.Lines.Add('GetProjParams: ' + SelectedFile);
    toks := SplitEx(String(pBuf), '');
    Begin
      For cnt := 0 To toks.Count - 1 Do
      Begin
        str1 := 'Parm: ' + IntToStr(cnt) + '-> ' + toks[cnt];
        Memo.Lines.Add('   ' + str1);
      End;
    End;
    // file is now closed by DLL
    CloseFile();
  End
  Else
    Memo.Lines.Add('GetProjParams: no File selected');
End;

{-----------------------------------------------------------------------------}
Procedure TForm1.btnInitChannelClick(Sender: TObject);
Var
  res               : integer;
  strRes            : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;
Begin
  pBuf := @stBuffer;
  statusBar.Panels[0].Text := '';
  InitChannel(0, res, pBuf);
  strRes := pBuf;
  Memo.Lines.Add('Initchannel Channel: 0 ' +
    '-> Result: ' + GetTyp(res) + ', Message: ' + strRes);

  If tprgResult(res) = progFound Then
  Begin
    groupBox2.Enabled := true;
    groupBox3.Enabled := true;
    groupBox4.Enabled := true;
    btnGetFiles.Enabled := true;
    btnTargetVoltage.Enabled := true;
    btnDownloadFile.Enabled := true;
  End
End;
{-----------------------------------------------------------------------------}

Procedure TForm1.btnGetFilesClick(Sender: TObject);
Var
  res, cnt          : integer;
  filesFound        : integer;
  strRes            : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;
  toks              : ISTrings;
  value             : String;
Begin
  pBuf := @stBuffer;
  statusBar.Panels[0].Text := '';
  comboBoxFiles.Items.Clear();
  comboBoxFiles.Text := '';
  GetFileNames(0, res, pBuf);
  strRes := String(pBuf);
  filesFound := 0;

  Memo.Lines.Add('GetFileNames Channel: 0' +
    '-> Result: ' + GetTyp(res));
  If tprgResult(res) = resOk Then
  Begin
    toks := SplitEx(String(pBuf), '');
    For cnt := 0 To toks.Count - 1 Do
    Begin
      value := toks[cnt];
      If value <> '' Then
      Begin
        inc(filesFound);
        comboBoxFiles.Items.Add(value);
        Memo.Lines.Add('GetFileNames Channel: 0, Place: ' + IntToStr(cnt) + ' -> ' + value);
      End;
    End;
    comboBoxFiles.Enabled := true;
  End;
  If (filesFound > 0) Then
  Begin
    statusBar.Panels[0].Text := 'Files found: ' + IntToStr(filesFound);
    comboBoxFiles.ItemIndex := 0;
    btnOpenAFile.Enabled := true;
    btnDeleteFile.Enabled := true;
    btnGetProjParams.Enabled := true;
    SelectedFile := comboboxFiles.items[comboboxFiles.itemindex];
  End;
End;

{-----------------------------------------------------------------------------}
Procedure TForm1.CloseFile;
Var
  res, cnt          : integer;
  strRes            : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;

Begin
  pBuf := @stBuffer;
  statusBar.Panels[0].Text := '';
  CloseAfile(0, res, pBuf);
  strRes := pBuf;
  Memo.Lines.Add('CloseAfile Channel: 0' +
    '-> Result: ' + GetTyp(res) + ', Message: ' + strRes);
  // if tprgResult(res) = progFound then
  Begin
    groupBox2.Enabled := true;
    btnGetFiles.Enabled := true;
    btnTargetVoltage.Enabled := true;
    btnOpenAFile.Caption := 'OpenAfile';
    btnEraseDevice.Enabled := false;
    btnVerifyAll.Enabled := false;
    btnGetFuses.Enabled := false;
    btnProgDevice.Enabled := false;
    comboBoxFiles.Enabled := true;
    btnGetFiles.Enabled := true;
    FileIsOpen := false;
    statusBar.Panels[0].Text := ' FileOpen: none';
  End;
End;
{-----------------------------------------------------------------------------}
Procedure TForm1.btnOpenAFileClick(Sender: TObject);
Var
  res, cnt          : integer;
  strRes            : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;
Begin
  If (SelectedFile <> '') Then
  Begin
    If (Not FileIsOpen) Then
    Begin
      pBuf := @stBuffer;
      OpenAfile(0, PChar(SelectedFile), res, pBuf);
      strRes := pBuf;
      statusBar.Panels[0].Text := ' FileOpen: ' + SelectedFile;
      Memo.Lines.Add('OpenAFile Channel: 0 , ' + SelectedFile +
        ' -> Result: ' + GetTyp(res) + ', Message: ' + strRes);
      If tprgResult(res) = resOk Then
      Begin
        // btnGetFiles.Enabled = true;
        btnEraseDevice.Enabled := true;
        btnProgDevice.Enabled := true;
        btnVerifyAll.Enabled := true;
        btngetFuses.Enabled := true;
        FileIsOpen := true;
        btnOpenAFile.Caption := 'CloseAfile';
        btnGetFiles.Enabled := false;
        comboBoxFiles.Enabled := false;
      End;
    End
    Else
    Begin
      CloseFile();
    End;
  End
  Else
  Begin
    Memo.Lines.Add('OpenAFile Channel: 0 , ERROR : not File seleted !!');
  End;
End;
{-----------------------------------------------------------------------------}
procedure TForm1.comboBoxFilesChange(Sender: TObject);
begin
  SelectedFile := comboboxFiles.items[comboboxFiles.itemindex];
end;

Procedure TForm1.comboBoxFilesSelect(Sender: TObject);
Begin
  SelectedFile := comboboxFiles.items[comboboxFiles.itemindex];
End;
{-----------------------------------------------------------------------------}
Procedure TForm1.btnDeleteFileClick(Sender: TObject);
Var
  res               : integer;
  strRes            : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;
Begin
  statusBar.Panels[0].Text := '';
  pBuf := @stBuffer;

  If (SelectedFile <> '') Then
  Begin
    If (Not FileIsOpen) Then
    Begin
      If (MessageDlg(PAnsiChar('Delete file ' + SelectedFile), mtConfirmation, [mbYes, mbNo], 0) = mrYes) Then
      Begin
        DeleteAfile(0, Pchar(SelectedFile), res, pBuf);
        strRes := pbuf;
        statusBar.Panels[0].Text := ' FileOpen: ' + SelectedFile;
        Memo.Lines.Add('DeleteAfile Channel: 0 ,' + SelectedFile +
          ' -> Result: ' + GetTyp(res) + ', Message: ' + strRes);
        If tprgResult(res) = resOk Then
        Begin
          btnGetFilesClick(Sender);
        End;
      End;
    End
    Else
    Begin
      CloseFile();
    End;
  End
  Else
  Begin
    Memo.Lines.Add
      ('DeleteAfile Channel: 0 , ERROR : not File seleted !!');
  End;
End;
{-----------------------------------------------------------------------------}
Procedure TForm1.btnDownloadFileClick(Sender: TObject);
Var
  res               : integer;
  strRes            : String;
  strFile           : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;
Begin
  statusBar.Panels[0].Text := '';
  pBuf := @stBuffer;
  TimerProgStatus.Enabled := false;
  Try
    Begin
      If (Not FileIsOpen) Then          // !! or try GetFileState() to verify no file is open
      Begin
        OpenDialog1.FileName := '';
        If (OpenDialog1.Execute()) Then
        Begin
          strFile := OpenDialog1.FileName;
          If (strFile = '') Then
            exit;
        End;
        Memo.Lines.Add('DownloadAFile in progress ' + UpperCase(ExtractFileName(strFile)) + ' .....');
        groupBox1.Enabled := false;
        Application.ProcessMessages();
        Screen.Cursor := crHourGlass;
        DownloadFile(0, PChar(strFile), res, pbuf);
        strRes := pbuf;
        Memo.Lines.Add('DownloadAFile Channel: 0 -> Result: ' +
          GetTyp(res) + ', Message: ' + strRes);
        If tprgResult(res) = resOk Then
        Begin
          btnGetFilesClick(Sender);
        End;
      End
      Else
      Begin
        Memo.Lines.Add
          ('DownloadAFile Channel: 0 , ERROR :  File is open !!');
      End
    End;
  Finally
    groupBox1.Enabled := true;
    Screen.Cursor := crDefault;
  End;
End;
{-----------------------------------------------------------------------------}
Procedure TForm1.btnEraseDeviceClick(Sender: TObject);
Var
  res               : integer;
  strRes            : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;
Begin
  statusBar.Panels[0].Text := '';
  pBuf := @stBuffer;
  EraseDevice(0, res, pBuf);
  strRes := pBuf;
  Memo.Lines.Add('EraseDevice Channel: 0' +
    '-> Result: ' + GetTyp(res) + ', Message: ' + strRes);
End;
{-----------------------------------------------------------------------------}
Procedure TForm1.btnTargetVoltageClick(Sender: TObject);
Var
  res               : integer;
  strRes            : String;
  Volt              : integer;
  realVolt          : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;
Begin
  statusBar.Panels[0].Text := '';
  pBuf := @stBuffer;
  volt := 0;
  GetTargVolt(0, Volt, res, pBuf);
  strRes := pBuf;
  If (Volt <> 0) Then
  Begin
    realVolt := FloatToStr(Volt / 100) + ' Volt ';
  End
  Else
  Begin
    realVolt := '0.0 Volt ';
  End;
  Memo.Lines.Add('GetTargVolt Channel: 0 , ' +
    '-> Result: ' + GetTyp(res) + ', Message: ' + strRes + ' Volt');
End;

{-----------------------------------------------------------------------------}
Procedure TForm1.btnProgDeviceClick(Sender: TObject);
Var
  res               : integer;
  strRes            : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;
  strData           : String;
  adr               : integer;
Begin
  statusBar.Panels[0].Text := '';

  If (FileIsOpen) Then
  Begin
    pBuf := @stBuffer;
    If (cbDownOverFlash.Checked) Then
    Begin
      //  usable for patching a serial number or a MAC address
      //  while programming the selected memory type , max 32 bytes
      //  or
      //  DownOverBlockE for EEprom
      //  DownOverBlockU for UserRow
      strData := edSerial.Text;
      adr := StrToInt(edDownOverAddr.Text);
      DownOverBlockF(0, @strData, adr, SizeOf(strData), res, pbuf);
      strRes := pbuf;
      Memo.Lines.Add('ProgDevice DownOverBlockF is set : 0 -> Result: ' +
        GetTyp(res) + ', Message: ' + strRes);
      If tprgResult(res) = resOk Then
        exit;
    End;

    ProgDevice(0, res, pBuf);
    strRes := pBuf;
    Memo.Lines.Add('ProgDevice Channel: 0' +
      '-> Result: ' + GetTyp(res) + ', Message: ' + strRes);
    If tprgResult(res) = resOk Then
    Begin
      StartTime := GetTickCount;
      cStatus := cProg;
      TimerProgStatus.Enabled := true;
    End;

  End
  Else
  Begin
    Memo.Lines.Add('ProgDevice Channel: 0 , ERROR : no File open !!');
  End;
End;

{-----------------------------------------------------------------------------}
Procedure TForm1.btnVerifyAllClick(Sender: TObject);
Var
  res               : integer;
  strRes            : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;
Begin
  statusBar.panels[0].Text := '';
  If (FileIsOpen) Then
  Begin
    pBuf := @stBuffer;
    VerifyDevice(0, res, pBuf);
    strRes := pBuf;
    Memo.Lines.Add('VerifyDevice Channel: 0' +
      '-> Result: ' + GetTyp(res) + ', Message: ' + strRes + CRLF);
    If tprgResult(res) = resOk Then
    Begin
      StartTime := GetTickCount;
      cStatus := cProg;
      TimerProgStatus.Enabled := true;
    End;
  End
  Else
  Begin
    Memo.Lines.Add('VerifyDevice Channel: 0 , ERROR : no File open !!');
  End;
End;
{-----------------------------------------------------------------------------}
Procedure TForm1.btngetFusesClick(Sender: TObject);
Var
  res               : integer;
  strRes            : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;
  Locks, fuseLo, fuseHi, fuseExt, fuseI, fuseJ,
    fuseK, Cal0, Cal1, Cal2, Cal3: integer;
Begin
  statusBar.Panels[0].Text := '';
  If FileIsOpen Then
  Begin
    Screen.Cursor := crHourGlass;
    Try
      // "L", "F", "H", "E", "0", "1", "2", "3"
      pBuf := @stBuffer;
      GetFuses(0, 'L', Locks, res, pBuf);
      If tprgResult(res) <> resOk Then
      Begin
        strRes := pBuf;
        Memo.Lines.Add('GetFuse Channel: 0' +
          '-> Result: ' + GetTyp(res) + ', Message: ' + strRes +
          '    , Atmel fuse notation  enabled = 0, disabled = 1 ');
        // Exit !!!!!!
      End;
      GetFuses(0, 'F', fuseLo, res, pBuf); // Fuse 0
      // todo Error check
      GetFuses(0, 'H', fuseHi, res, pBuf); // Fuse 1
      // todo Error check ...
      GetFuses(0, 'E', fuseExt, res, pBuf); // Fuse 2
      GetFuses(0, 'I', fuseI, res, pBuf); // Fuse 3
      GetFuses(0, 'J', fuseJ, res, pBuf); // Fuse 4
      GetFuses(0, 'K', fuseK, res, pBuf); // Fuse 5
      GetFuses(0, '0', Cal0, res, pBuf);
      GetFuses(0, '1', Cal1, res, pBuf);
      GetFuses(0, '2', Cal2, res, pBuf);
      GetFuses(0, '3', Cal3, res, pBuf);

      Memo.Lines.Add('   Lockbits : $' + IntToHex(Locks, 2));
      Memo.Lines.Add('   Fuse0    : $' + IntToHex(fuseLo, 2));
      Memo.Lines.Add('   Fuse1    : $' + IntToHex(fuseHi, 2));
      Memo.Lines.Add('   Fuse2    : $' + IntToHex(fuseExt, 2));
      Memo.Lines.Add('   Fuse3    : $' + IntToHex(fuseI, 2));
      Memo.Lines.Add('   Fuse4    : $' + IntToHex(fuseJ, 2));
      Memo.Lines.Add('   Fuse5    : $' + IntToHex(fuseK, 2));
      Memo.Lines.Add('   Cal0     : $' + IntToHex(Cal0, 2));
      Memo.Lines.Add('   Cal1     : $' + IntToHex(Cal1, 2));
      Memo.Lines.Add('   Cal2     : $' + IntToHex(Cal2, 2));
      Memo.Lines.Add('   Cal3     : $' + IntToHex(Cal3, 2));

    Finally
      Screen.Cursor := crDefault;
    End;
  End
  Else
  Begin
    Memo.Lines.Add('GetFuse Channel: 0 , ERROR : no File open !');
  End;

End;

{-----------------------------------------------------------------------------}
Procedure TForm1.TimerProgStatusTimer(Sender: TObject);
Var
  res, idx          : integer;
  allIdle           : integer;
  strRes            : String;
  stBuffer          : Array[0..512] Of char;
  pBuf              : PChar;

Begin
  pBuf := @stBuffer;
  statusBar.Panels[0].Text := '';
  allIdle := 0;
  groupBox2.Enabled := false;
  For idx := 0 To ProgrammersFound Do
  Begin
    If (cStatus <> cIdle) Then
    Begin

      GetProgStatus(idx, res, pBuf);
      strRes := pBuf;
      If (strLast <> strRes) Then
      Begin
        strLast := strRes;
        Case tprgResult(res) Of
          progDone:
            Begin
              EndTime := GetTickCount;
              Memo.Lines.Add(CRLF + 'GetProgStatus > done < :) in ' + FloatToStr((EndTime - StartTime) / 1000) +
                ' sec');
              ReleaseTarget(0, res, pBuf);
              strRes := pBuf;
              // if desired !!
              Memo.Lines.Add('ReleaseTarget Channel: 0 ' +
                ' - > Result: ' + GetTyp(res) + ', Message: ' + strRes);
              SendMessage(Memo.Handle, WM_VSCROLL, SB_Bottom, 0);
              groupBox2.Enabled := true;
              cStatus := cIdle;
              inc(allIdle);
              Beep;
              statusBar.Panels[0].Text := 'programming finished';
            End;
          eraChip:
            Begin
              Memo.Lines.Add(CRLF + 'GetProgStatus > c < erase Chip');
            End;
          verifyUsrRow:
            Begin
              Memo.Lines.Add(CRLF + 'GetProgStatus > U < verify UserRow' + CRLF);
            End;
          prgUsrRow:
            Begin
              Memo.Lines.Add(CRLF + 'GetProgStatus > U < Program UserRow' + CRLF);
            End;

          verifyEEp:
            Begin
              Memo.Lines.Add(CRLF + 'GetProgStatus > E < verify EEprom' + CRLF);
            End;
          prgEEp:
            Begin
              Memo.Lines.Add(CRLF + 'GetProgStatus > E < Program EEprom' + CRLF);
              SendMessage(Memo.Handle, WM_VSCROLL, SB_Bottom, 0);
            End;
          verifyFlash:
            Begin
              Memo.Lines.Add(CRLF + 'GetProgStatus > V < verify Flash' + CRLF);
              SendMessage(Memo.Handle, WM_VSCROLL, SB_Bottom, 0);
            End;
          prgFlash:
            Begin
              Memo.Lines.Add(CRLF + 'GetProgStatus > F < Program Flash' + CRLF);
              SendMessage(Memo.Handle, WM_VSCROLL, SB_Bottom, 0);
            End;
          limitExc,
            PwrDownErr,
            SignatureErr,
            ProtectedErr,
            NotEmptyErr,
            VerifyErr,
            FileErr:
            Begin
              groupBox2.Enabled := true;
              cStatus := cIdle;
              inc(allIdle);
              Memo.Lines.Add(CRLF + 'GetProgStatus > Error < ');
              SendMessage(Memo.Handle,
                WM_VSCROLL,
                SB_PAGEDOWN,
                0);
            End;
          progTimeOutErr:
            Begin
              groupBox2.Enabled := true;
              allIdle := 999;
              cStatus := cIdle;
              Memo.Lines.Add(CRLF + 'GetProgStatus > 8 < communication TimeOut');
              SendMessage(Memo.Handle,
                WM_VSCROLL,
                SB_PAGEDOWN,
                0)
            End;
        Else
          Begin
          End;
        End;                            //case
      End
      Else
      Begin
        Memo.Lines.BeginUpdate;
        Memo.Lines.Text := Memo.Lines.Text + ('*');
        SendMessage(Memo.Handle,WM_VSCROLL,SB_PAGEDOWN,0);
        Memo.Lines.EndUpdate;
      End;                              // strLast
    End
    Else
    Begin
      inc(allIdle);
    End;
  End;
  If (allIdle >= ProgrammersFound) Then
  Begin
    TimerProgStatus.Enabled := false;
    groupBox2.Enabled := true;
  End;
End;

{-----------------------------------------------------------------------------}
End.

